#pragma once
#include "Entity.h"
#include "EntityStateSplash.h"
#define CS_ENEMY_SKULLHEAD_CREATENAME L"CS_enemy_skullhead"
class CS_Enemy_Crow_SkullheadCatcher;
class CS_Enemy_Skullhead :
    public Entity
{
public:
    CS_Enemy_Skullhead();
    void Init(std::weak_ptr<Entity> self) override;
    void Step() override;
    void SetState(int stateID, int lr) override;
    void Attack(std::weak_ptr<Entity> dst, int* outDamage, float* outAngle, bool* outTakedown, int* outElemType, float* outShockForce, float* outHeavy) override;
    bool Hurt(std::weak_ptr<Entity> src, int getDamage, float angle, bool bTakedown, int elemType, float shockForce, float heavy, int* outRealDamage) override;
    std::weak_ptr<Entity> BeginCaught(std::weak_ptr<Entity> e) override;//开始被某单位抓取（切换到被抓取状态）
    void EndCaught(std::weak_ptr<Entity> e) override;//被某单位抓取结束(退出被抓取状态）
    EntityStateSplash stateSplash;
    int act_no = 0;
    int count1 = 0;
    int count2 = 0;
    std::weak_ptr<CS_Enemy_Crow_SkullheadCatcher> pCrow;
    int act_wait = 0;
};

std::shared_ptr<Entity> CreateCS_Enemy_Skullhead();